Bug 838756 - Review Request: maven-indexer - Standard for producing indexes of Maven repositories
Review Request: maven-indexer - Standard for producing indexes of Maven repos...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mikolaj Izdebski
Fedora Extras Quality Assurance
:
Depends On: 836850 838722
Blocks:
  Show dependency treegraph
 
Reported: 2012-07-09 21:57 EDT by Gerard Ryan
Modified: 2012-08-08 09:35 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-05 17:21:55 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mizdebsk: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Gerard Ryan 2012-07-09 21:57:55 EDT
Spec URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-1/maven-indexer.spec
SRPM URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-1/maven-indexer-4.1.2-1.fc17.src.rpm
Description:
Apache Maven Indexer (former Sonatype Nexus Indexer) is the defacto
standard for producing indexes of Maven repositories. The Indexes
are produced and consumed by all major tools in the ecosystem.

Fedora Account System Username: galileo
Comment 1 Gerard Ryan 2012-07-09 22:10:35 EDT
I think Patch1 is F17 specific, and I don't know if it will work at all with f18, it shouldn't be necessary anyway because of the more advanced lucene version.

What's the recommended way to conditionally apply a patch based on release version?
Comment 2 Gerard Ryan 2012-07-24 21:23:31 EDT
(In reply to comment #1)
> What's the recommended way to conditionally apply a patch based on release
> version?

Nevermind, just having the patch in the fedora branch is the obvious answer to this. It builds with the patch on f18, but I've removed it because of it's F17 specificity. I'll add it to the F17 branch alone.
Comment 3 Mikolaj Izdebski 2012-07-25 08:15:53 EDT
I am taking this review.
Comment 4 Gerard Ryan 2012-07-25 09:28:49 EDT
Bundled jars removed from the source zip in the srpm so that the terms of their licenses are not violated

Spec URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-2/maven-indexer.spec
SRPM URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-2/maven-indexer-4.1.2-2.fc17.src.rpm
Comment 5 Mikolaj Izdebski 2012-07-25 10:32:34 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated


==== Generic ====
[!]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
[!]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[x]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[x]: MUST Package contains desktop file if it is a GUI application.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[!]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[x]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
[x]: MUST License file installed when any subpackage combination is installed.
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[!]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[x]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[?]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.


==== Java ====
[x]: MUST If source tarball includes bundled jar/class files these need to be
     removed prior to building
[x]: MUST Packages have proper BuildRequires/Requires on jpackage-utils
[x]: MUST Fully versioned dependency in subpackages, if present.
[x]: MUST Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: MUST Javadoc subpackages have Requires: jpackage-utils
[x]: MUST Javadocs are placed in %{_javadocdir}/%{name} (no -%{version}
     symlink)
[x]: SHOULD Package has BuildArch: noarch (if possible)
[x]: SHOULD Package uses upstream build method (ant/maven/etc.)


==== Maven ====
[x]: MUST Pom files have correct add_maven_depmap call
[x]: MUST Old add_to_maven_depmap macro is not being used
[x]: MUST Packages DOES NOT have Requires(post) and Requires(postun) on
     jpackage-utils for %update_maven_depmap macro
[x]: MUST If package contains pom.xml files install it (including depmaps)
     even when building with ant
[x]: MUST Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: MUST Packages use %{_mavenpomdir} instead of %{_datadir}/maven2/poms

Rpmlint
-------
Checking: maven-indexer-4.1.2-2.fc18.noarch.rpm
          maven-indexer-4.1.2-2.fc18.src.rpm
          maven-indexer-javadoc-4.1.2-2.fc18.noarch.rpm
maven-indexer.noarch: I: enchant-dictionary-not-found en_US
maven-indexer.src:23: W: macro-in-comment %{name}
maven-indexer.src: W: invalid-url Source0: maven-indexer-4.1.2-source-release.zip
3 packages and 0 specfiles checked; 0 errors, 2 warnings.

Issues
------

[!]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

The LICENSE file must be included in the SRPM and installed as %doc.
This is required by the point 4. of the license.

[!]: MUST Package contains no bundled libraries.

/usr/share/java/maven-indexer-core-cli.jar contains bundled libraries.
Please remove them. See:
http://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

[!]: MUST Package complies to the Packaging Guidelines

Packaging guidelines says "If the number of provided JAR files exceeds
two, you MUST place them into a sub-directory named %{name}."
Please obey this rule. See:
http://fedoraproject.org/wiki/Packaging:Java#Installation_directory
Comment 6 Gerard Ryan 2012-07-25 15:51:46 EDT
(In reply to comment #5)
> The LICENSE file must be included in the SRPM and installed as %doc.
> This is required by the point 4. of the license.

It's already being installed as %doc, and by extension is included in the SRPM, right?

> /usr/share/java/maven-indexer-core-cli.jar contains bundled libraries.
> Please remove them. See:
> http://fedoraproject.org/wiki/Packaging:No_Bundled_Libraries

Done. The entire jar was bundled libs. Turns out that's what maven-shade-plugin does...I guess maven-shade-plugin shouldn't be used in any fedora packages in this case.

> Packaging guidelines says "If the number of provided JAR files exceeds
> two, you MUST place them into a sub-directory named %{name}."
> Please obey this rule. See:
> http://fedoraproject.org/wiki/Packaging:Java#Installation_directory

Ah yeah, I (incorrectly) was looking at the draft guidelines, where the MUST is substituted for a CAN:
https://fedoraproject.org/w/index.php?title=User:Akurtakov/JavaPackagingDraftUpdate#Installation_directory

Anyway, the uber-jar is no longer being installed, so this no longer applies :)

Spec URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-3/maven-indexer.spec
SRPM URL: http://galileo.fedorapeople.org/maven-indexer/4.1.2-3/maven-indexer-4.1.2-3.fc17.src.rpm
Comment 7 Mikolaj Izdebski 2012-07-25 16:49:29 EDT
(In reply to comment #6)
> (In reply to comment #5)
> > The LICENSE file must be included in the SRPM and installed as %doc.
> > This is required by the point 4. of the license.
> 
> It's already being installed as %doc, and by extension is included in the
> SRPM, right?

My bad. You were right.

> Anyway, the uber-jar is no longer being installed, so this no longer applies
> :)
Nice :)


[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package contains no bundled libraries.
[x]: MUST Package complies to the Packaging Guidelines

rpmlint output:
maven-indexer.noarch: I: enchant-dictionary-not-found en_US
maven-indexer.src: W: invalid-url Source0: maven-indexer-4.1.2-source-release.zip
3 packages and 0 specfiles checked; 0 errors, 1 warnings.

No more issues.

*************
** APPROVED**
*************
Comment 8 Mikolaj Izdebski 2012-07-25 16:50:24 EDT
Tested on Koji: http://koji.fedoraproject.org/koji/taskinfo?taskID=4329789
Comment 9 Gerard Ryan 2012-07-25 16:52:49 EDT
New Package SCM Request
=======================
Package Name: maven-indexer
Short Description: Standard for producing indexes of Maven repositories
Owners: galileo
Branches: f17
InitialCC:
Comment 10 Gwyn Ciesla 2012-07-26 06:32:00 EDT
Git done (by process-git-requests).
Comment 11 Fedora Update System 2012-07-26 12:57:04 EDT
maven-indexer-4.1.2-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/maven-indexer-4.1.2-3.fc17
Comment 12 Fedora Update System 2012-07-26 18:30:01 EDT
maven-indexer-4.1.2-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 13 Fedora Update System 2012-08-05 17:21:55 EDT
maven-indexer-4.1.2-3.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.